diff --git a/platforms/astbmc/garrison.c b/platforms/astbmc/garrison.c
index 4b3ba071a833..a467672ea7a0 100644
--- a/platforms/astbmc/garrison.c
+++ b/platforms/astbmc/garrison.c
@@ -63,20 +63,6 @@ static const struct slot_table_entry garrison_phb0_3_slot[] = {
 	{ .etype = st_end },
 };
 
-static const struct slot_table_entry garrison_npu0_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU2",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU1",
-	},
-	{ .etype = st_end },
-};
-
 static const struct slot_table_entry garrison_phb1_0_slot[] = {
 	{
 		.etype = st_pluggable_slot,
@@ -144,20 +130,6 @@ static const struct slot_table_entry garrison_phb1_3_slot[] = {
 	{ .etype = st_end },
 };
 
-static const struct slot_table_entry garrison_npu1_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU4",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU3",
-	},
-	{ .etype = st_end },
-};
-
 static const struct slot_table_entry garrison_phb_table[] = {
 	{
 		.etype = st_phb,
@@ -181,11 +153,6 @@ static const struct slot_table_entry garrison_phb_table[] = {
 	},
 	{
 		.etype = st_phb,
-		.location = ST_LOC_PHB(0,4),
-		.children = garrison_npu0_slots,
-	},
-	{
-		.etype = st_phb,
 		.location = ST_LOC_PHB(1,0),
 		.children = garrison_phb1_0_slot,
 	},
@@ -204,11 +171,6 @@ static const struct slot_table_entry garrison_phb_table[] = {
 		.location = ST_LOC_PHB(1,3),
 		.children = garrison_phb1_3_slot,
 	},
-	{
-		.etype = st_phb,
-		.location = ST_LOC_PHB(1,4),
-		.children = garrison_npu1_slots,
-	},
 	{ .etype = st_end },
 };
 
diff --git a/platforms/astbmc/p8dnu.c b/platforms/astbmc/p8dnu.c
index 1ac2a2141dbb..5502af86bdaf 100644
--- a/platforms/astbmc/p8dnu.c
+++ b/platforms/astbmc/p8dnu.c
@@ -105,20 +105,6 @@ static const struct slot_table_entry p8dnu_phb0_3_slot[] = {
 	{ .etype = st_end },
 };
 
-static const struct slot_table_entry p8dnu_npu0_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU2",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU1",
-	},
-	{ .etype = st_end },
-};
-
 static const struct slot_table_entry p8dnu_phb1_0_slot[] = {
 	{
 		.etype = st_pluggable_slot,
@@ -186,20 +172,6 @@ static const struct slot_table_entry p8dnu_phb1_3_slot[] = {
 	{ .etype = st_end },
 };
 
-static const struct slot_table_entry p8dnu_npu1_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU4",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU3",
-	},
-	{ .etype = st_end },
-};
-
 static const struct slot_table_entry p8dnu_phb_table[] = {
 	{
 		.etype = st_phb,
@@ -223,11 +195,6 @@ static const struct slot_table_entry p8dnu_phb_table[] = {
 	},
 	{
 		.etype = st_phb,
-		.location = ST_LOC_PHB(0,4),
-		.children = p8dnu_npu0_slots,
-	},
-	{
-		.etype = st_phb,
 		.location = ST_LOC_PHB(1,0),
 		.children = p8dnu_phb1_0_slot,
 	},
@@ -246,11 +213,6 @@ static const struct slot_table_entry p8dnu_phb_table[] = {
 		.location = ST_LOC_PHB(1,3),
 		.children = p8dnu_phb1_3_slot,
 	},
-	{
-		.etype = st_phb,
-		.location = ST_LOC_PHB(1,4),
-		.children = p8dnu_npu1_slots,
-	},
 	{ .etype = st_end },
 };
 
diff --git a/platforms/astbmc/witherspoon.c b/platforms/astbmc/witherspoon.c
index c3e997a393ac..4f384db77b5b 100644
--- a/platforms/astbmc/witherspoon.c
+++ b/platforms/astbmc/witherspoon.c
@@ -110,44 +110,6 @@ static const struct slot_table_entry witherspoon_phb8_5_slot[] = {
 	{ .etype = st_end },
 };
 
-static const struct slot_table_entry witherspoon_npu0_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU0",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU1",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(2),
-		.name = "GPU2",
-	},
-	{ .etype = st_end },
-};
-
-static const struct slot_table_entry witherspoon_npu8_slots[] = {
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(0),
-		.name = "GPU3",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(1),
-		.name = "GPU4",
-	},
-	{
-		.etype = st_npu_slot,
-		.location = ST_LOC_NPU_GROUP(2),
-		.name = "GPU5",
-	},
-	{ .etype = st_end },
-};
-
 static const struct slot_table_entry witherspoon_phb_table[] = {
 	{
 		.etype = st_phb,
@@ -156,19 +118,9 @@ static const struct slot_table_entry witherspoon_phb_table[] = {
 	},
 	{
 		.etype = st_phb,
-		.location = ST_LOC_PHB(0,7),
-		.children = witherspoon_npu0_slots,
-	},
-	{
-		.etype = st_phb,
 		.location = ST_LOC_PHB(8,5),
 		.children = witherspoon_phb8_5_slot,
 	},
-	{
-		.etype = st_phb,
-		.location = ST_LOC_PHB(8,8),
-		.children = witherspoon_npu8_slots,
-	},
 	{ .etype = st_end },
 };
 